--{{{ Libraries

local RL = AceLibrary("Roster-2.1")
local Aura = AceLibrary("SpecialEvents-Aura-2.0")
local L = AceLibrary("AceLocale-2.2"):new("GridStatusHots")

--}}}
--

local timer1 = { }
local timer2 = { }
--local hotcache = { }
local playerClass, englishClass = UnitClass("player");
local hotspell=nil
local hotspellduration=nil
local gsh_target=nil
local dbsettings=nil

GridStatusHots = GridStatus:NewModule("GridStatusHots")
GridStatusHots.menuName = "nil"
GridStatusHots.options = false

--{{{ Localization

L:RegisterTranslations("enUS", function()
	return {
		["Renew"] = true,
		["Rejuvenation"] = true,
		["Regrowth"] = true,
		["Buff: Hot Count"] = true,
		["Buff: My Renew"] = true,
		["Buff: My Rejuvenation"] = true,
		["Buff: My Regrowth"] = true,
	}
end)

L:RegisterTranslations("deDE", function() 
	return {
		["Renew"] = "Erneuerung",
		["Rejuvenation"] = "Verj\195\188ngung",
		["Regrowth"] = "Nachwachsen",
		["Buff: Hot Count"] = true,
		["Buff: My Renew"] = true,
		["Buff: My Rejuvenation"] = true,
		["Buff: My Regrowth"] = true,
	}
end)

L:RegisterTranslations("koKR", function() 
	return {
		["Renew"] = "소생",
		["Rejuvenation"] = "회복",
		["Regrowth"] = "재생",
		["Buff: Hot Count"] = true,
		["Buff: My Renew"] = true,
		["Buff: My Rejuvenation"] = true,
		["Buff: My Regrowth"] = true,
	}
end)

L:RegisterTranslations("frFR", function() 
	return {
		["Renew"] = "R\195\169novation",
		["Rejuvenation"] = "R\195\169cup\195\169ration",
		["Regrowth"] = "R\195\169tablissement",
		["Buff: Hot Count"] = true,
		["Buff: My Renew"] = true,
		["Buff: My Rejuvenation"] = true,
		["Buff: My Regrowth"] = true,
	}
end)

L:RegisterTranslations("zhCN", function() 
	return {
		["Renew"] = "\230\191\162\229\164\191",
		["Rejuvenation"] = "\229\155\158\230\152\165\230\156\175",
		["Regrowth"] = "\230\132\136\229\191\136",
		["Buff: Hot Count"] = true,
		["Buff: My Renew"] = true,
		["Buff: My Rejuvenation"] = true,
		["Buff: My Regrowth"] = true,
	}
end)

--}}}

--{{{ AceDB defaults
--
GridStatusHots.defaultDB = {
	debug = false,
	alert_renew = {
		enable = true,
		priority = 99,
		range = false,
		color = { r = 0, g = 1, b = 0, a = 1 },
	},
	alert_rejuv = {
		enable = true,
		priority = 99,
		range = false,
		color = { r = 0, g = 0, b = 1, a = 1 },
	},
	alert_regrow = {
		enable = true,
		priority = 98,
		range = false,
		color = { r = 1, g = 1, b = 1, a = 1 },
	},
	alert_tothots = {
		enable = true,
		priority = 97,
		range = false,
		color = { r = 0, g = 1, b = 0, a = 1 },
	},
}

--}}}

function GridStatusHots:OnInitialize()
	self.super.OnInitialize(self)
	self:RegisterStatus("alert_tothots", L["Buff: Hot Count"], alert_tothots, true)
	if englishClass == "PRIEST" then
		self:RegisterStatus("alert_renew", L["Buff: My Renew"], alert_renew, true)
	end
	if englishClass == "DRUID" then
		self:RegisterStatus("alert_rejuv", L["Buff: My Rejuvenation"], alert_rejuv, true)
		self:RegisterStatus("alert_regrow", L["Buff: My Regrowth"], alert_regrow, true)
	end
end

function GridStatusHots:OnEnable()
	self:RegisterEvent("UNIT_SPELLCAST_SENT")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED", "UpdateHots")
	self:RegisterEvent("SpecialEvents_UnitBuffLost", "StopHot")
	self:RegisterEvent("SpecialEvents_UnitBuffGained", "StopHot")
	self:RegisterEvent("UNIT_HEALTH", "UpdateAll")
	self:RegisterEvent("UNIT_MANA", "UpdateAll")
end

function GridStatusHots:Reset()
	self.super.Reset(self)
end

function GridStatusHots:UNIT_SPELLCAST_SENT(unit, spell, rank, target)
	-- Did you cast a HoT ?
	if spell == L["Renew"] then
		gsh_target = target
		hotspell = L["Renew"]
		hotspellduration = 14.9
		cstatus = "alert_renew"
		dbsettings=self.db.profile.alert_renew
	elseif spell == L["Rejuvenation"] then
		gsh_target = target
		hotspell = L["Rejuvenation"]
		hotspellduration = 11.9
		cstatus = "alert_rejuv"
		dbsettings=self.db.profile.alert_rejuv
	elseif spell == L["Regrowth"] then
		gsh_target = target
		hotspell = L["Regrowth"]
		hotspellduration = 20.9
		cstatus = "alert_regrow"
		dbsettings=self.db.profile.alert_regrow
	else
		gsh_target = nil
	end
end

function GridStatusHots:UpdateHots(target)
	GridStatusHots:UpdateAll()
	-- Time your HoT if spellcast was successful.
	if gsh_target and hotspell == L["Regrowth"] then
	        timer2[gsh_target] = { GetTime(), hotspellduration, cstatus, hotspell, dbsettings  }    
	        GridStatusHots:UpdateAll()
	elseif gsh_target then
		timer1[gsh_target] = { GetTime(), hotspellduration, cstatus, hotspell, dbsettings  }
		GridStatusHots:UpdateAll()
	end
end

function GridStatusHots:StopHot()

	GridStatusHots:UpdateAll()
	-- Loose status when time is up or buff is gone.
	for u in RL:IterateRoster() do
		local name = UnitName(u.unitid)
		if timer1[name] and (GetTime()-timer1[name][1]) > 1 then
			if (GetTime()-timer1[name][1]) > timer1[name][2] or not (Aura:UnitHasBuff(u.unitid, timer1[name][4])) then
				self.core:SendStatusLost(name, timer1[name][3])
				timer1[name] = nil
			end
		end
		if timer2[name] and (GetTime()-timer2[name][1]) > 1 then
			if (GetTime()-timer2[name][1]) > timer2[name][2] or not (Aura:UnitHasBuff(u.unitid, timer2[name][4])) then
				self.core:SendStatusLost(name, timer2[name][3])
				timer2[name] = nil
			end
		end
	end
end

function GridStatusHots:UpdateAll()
	for u in RL:IterateRoster() do
		local name = UnitName(u.unitid)
		local recnt = 0
		local rgcnt = 0
		local rjcnt = 0
		local hcnttxt = nil
		--hotcache[name] = { } 
		-- Find number of hots
		for i=1,40 do -- this is not raid numbers, its possible buffs/debuffs to scan per member,
			local bname,brank,btexture,bcount = UnitBuff(u.unitid, i)
			if not bname then break end
			self:Debug("banem:"..bname)
			if bname and bname == L["Renew"] then recnt = recnt + 1 end
			if bname and bname == L["Regrowth"] then rgcnt = rgcnt + 1 end
			if bname and bname == L["Rejuvenation"] then rjcnt = rjcnt + 1 end
		end
		-- Set status
		if recnt > 0 or rjcnt > 0 or rgcnt > 0 then
			hcnttxt = tostring(recnt+rjcnt+rgcnt)
			local settings = self.db.profile.alert_tothots
			self:Debug(settings.color)
			self.core:SendStatusGained(name, "alert_tothots",
				settings.priority,
				(settings.range and 40),
				settings.color,
				tostring(hcnttxt)
			)
		else
			self.core:SendStatusLost(name, "alert_tothots")
		end
		-- Add self thrown HoTs
		if timer1[name] then
			local settings = timer1[name][5]
			local text = timer1[name][2]-(GetTime()-timer1[name][1])
			self:Debug(text)
			self.core:SendStatusGained(name, timer1[name][3],
				settings.priority,
				(settings.range and 40),
				settings.color,
				tostring(math.floor(text).."-"..tostring(recnt+rjcnt+rgcnt))
			)
		end
		if timer2[name] then
			local settings = timer2[name][5]
			local text = timer2[name][2]-(GetTime()-timer2[name][1])
			self:Debug(text)
			self.core:SendStatusGained(name, timer2[name][3],
				settings.priority,
				(settings.range and 40),
				settings.color,
				tostring(math.floor(text).."-"..tostring(recnt+rjcnt+rgcnt))
			)
		end
	end
end		


